'use strict';

var path = require("path");

var httpsTransMap = {
    // 原生支持HTTPS的服务-百度内
    "http://baike.baidu.com": "https://bkssl.bdimg.com",
    "http://wapbaike.baidu.com": "https://wapbaike.baidu.com",
    "http://baike.bdimg.com": "https://baike.bdimg.com",
    "http://baikebcs.bdimg.com": "https://baikebcs.bdimg.com",
    "http://hiphotos.baidu.com": "https://imgsa.baidu.com",
    "http://imgsrc.baidu.com": "https://imgsa.baidu.com",
    "http://a.hiphotos.baidu.com": "https://imgsa.baidu.com",
    "http://b.hiphotos.baidu.com": "https://imgsa.baidu.com",
    "http://c.hiphotos.baidu.com": "https://imgsa.baidu.com",
    "http://d.hiphotos.baidu.com": "https://imgsa.baidu.com",
    "http://e.hiphotos.baidu.com": "https://imgsa.baidu.com",
    "http://f.hiphotos.baidu.com": "https://imgsa.baidu.com",
    "http://g.hiphotos.baidu.com": "https://imgsa.baidu.com",
    "http://h.hiphotos.baidu.com": "https://imgsa.baidu.com",
    "http://cdn00.baidu-img.cn": "https://timg01.bdimg.com",
    "http://m.baidu.com": "https://m.baidu.com",
    "http://drm.media.baidubce.com": "https://drm.media.baidubce.com",
    "http://bs.baidu.com": "https://baikebcs.bdimg.com",
    "http://passport.baidu.com": "https://passport.baidu.com",
    "http://wappass.baidu.com": "https://wappass.baidu.com",
    // 原生支持HTTPS的服务-百度外
    "http://jsapi.qq.com": "https://jsapi.qq.com",
    // 需要通过HTTPS代理的服务-百度内
    "http://img.baidu.com": "https://gss0.baidu.com/70cFsjip0QIZ8tyhnq",
    "http://himg.baidu.com" : "https://gss0.baidu.com/7Ls0a8Sm2Q5IlBGlnYG",
    "http://himg.bdimg.com" : "https://gss0.bdstatic.com/7Ls0a8Sm1A5BphGlnYG",
    "http://tts.baidu.com": "https://gss0.baidu.com/6KAZsjip0QIZ8tyhnq",
    "http://zhangmenshiting.baidu.com": "https://gss0.baidu.com/yrwHcj7d1QgTmNK7m9_UKT6zgBYnreHg-_",
    "http://nssug.baidu.com": "https://gsp0.baidu.com/8qUZeT8a2gU2pMbgoY3K",
    "http://msg.baidu.com": "https://gsp0.baidu.com/8_UFsjip0QIZ8tyhnq",
    "http://static.tieba.baidu.com": "https://gsp0.baidu.com/5aAHeD3nKhI2p27j8IqW0jdnxx1xbK"
    // 需要通过HTTPS代理的服务-百度外
}

// 对tpl的处理
function httpsTplReplace(content) {
    // 替换可能包含在smarty变量中的url
    return content.replace(/(?:src|img)="\{%(\$.*?)%\}"/gi, function(word, key){
        var ret = word.replace(key, key + '|wiki_common_https_trans');
        if( ret !== word) {
            console.log('🙆 ==> replacement 1::' + '[' + word + ']' + ' => [' + ret + ']');
        }
        return ret;
    })

    // 替换smarty和字符的combination
    .replace(/(src|img)="(http:\/\/[\.\w\/\-]+)\{%(\$.*?)%\}([\.\w\/\-]+)"/gi, function(word, s1, s2, s3, s4){
        var ret = s1 + '=\"{%\'' + s2  + '\'|cat:' + s3 + '|cat:\'' + s4 + '\'|wiki_common_https_trans%}\"';
        console.log('🙋 ==> replacement 2::' + '[' + word + ']' + ' => [' + ret + ']');
        return ret;
    })

    // 替换直接的图片地址
    .replace(/src="([^'"{}<>]+)"/gi, function(word, s){
        var key = s.split('.com')[0] + '.com';
        if(httpsTransMap[key]){
            var ret = '{%"' + s + '"|wiki_common_https_trans%}';
            console.log('👭 ==> replacement 3::' + '[' + word + ']' + ' => [' + ret + ']');
            return word.replace(s, ret);
        }
        return word;
    })

    // 替换纯baiduTemplate
    .replace(/(src|img)="<#=(.*?)#>"/gi, function(word, s1, s2){
        var ret = s1 + '="<#-__2ssl__(' + s2 + ')#>"';
        console.log('👑 ==> replacement 4::' + '[' + word + ']' + ' => [' + ret + ']');
        return ret;
    })

    // 替换baiduTemplate和字符串的组合
    .replace(/(src|img)="([^'"]+)<#:?=(.*?)#>([^'"]+)"/gi, function(word, s1, s2, s3, s4){
        var ret = s1 + '="<#-__2ssl__(\'' + s2.replace(/\//g, '\\/') + '\' + ' + s3 + ' + \'' + s4.replace(/\//g, '\\/') + '\')#>"';
        console.log('💏 ==> replacement 5::' + '[' + word + ']' + ' => [' + ret + ']');
        return ret;
    })

    // 替换baiduTemplate模板中包含在background中的变量
    .replace(/background(?:\-image)?:\s*(?:#(?:[A-Za-z0-9]{3}|[A-Za-z0-9]{6})\s+)?url\(['"]?<#:?=(.*?)#>['"]?\)/gi, function(word, key){
        var ret = word.replace(key, '__2ssl__(' + key + ')');
        if( ret !== word) {
            console.log('👀 ==> replacement 12::' + '[' + word + ']' + ' => [' + ret + ']');
        }
        return ret;
    })

    // 替换juicer模板
    .replace(/(src|img)="\${([^%]+?)}"/gi, function(word, s1, s2){
        var ret = s1 + '="${__2ssl__(' + s2 + ')}"';
        console.log('👪 ==> replacement 6::' + '[' + word + ']' + ' => [' + ret + ']');
        return ret;
    })

    // 替换juicer模板和字符串的组合
    .replace(/(src|img)="([^'"]+)\${([^%]+?)}([^'"]+)"/gi, function(word, s1, s2, s3, s4){
        var ret = s1 + '="${__2ssl__(\'' + s2 + '\' + ' + s3 + ' + \'' + s4 + '\')}"';
        console.log('👯 ==> replacement 7::' + '[' + word + ']' + ' => [' + ret + ']');
        return ret;
    })

     // 替换juicer模板中包含在background中的变量
    .replace(/background(?:\-image)?:\s*(?:#(?:[A-Za-z0-9]{3}|[A-Za-z0-9]{6})\s+)?url\(['"]?\$\{(.*?)\}['"]?\)/gi, function(word, key){
        var ret = word.replace(key, '__2ssl__(' + key + ')');
        if( ret !== word) {
            console.log('🙇 ==> replacement 11::' + '[' + word + ']' + ' => [' + ret + ']');
        }
        return ret;
    })

    // 替换json_encode的字符串
    .replace(/\{%.*?(\$(.+?)\|json_encode).*?%\}/gi, function(word, key){
        // eg. key = $btns|json_encode
        // 但是为什么json_encode的也要处理啊？
        var ret = word.replace(key, key + '|wiki_common_https_trans');
        if( ret !== word) {
            console.log('💃 ==> replacement 8::' + '[' + word + ']' + ' => [' + ret + ']');
        }
        return ret;
    })

    // 替换模板中包含在background中的smarty的变量
    // 添加(?:[^;]*)以匹配这种字段： "background:{%$data.bgColor%} {%if $lang == 'en'%}url({%$data.en_bgImg|wiki_common_pic_src2url%}){%else%}url({%$data.bgImg|wiki_common_pic_src2url%}){%/if%} center center  no-repeat;"
    // 2016-09-05 yuhui
    .replace(/background(?:\-image)?:\s*(?:#(?:[A-Za-z0-9]{3}|[A-Za-z0-9]{6})\s+)?(?:[^;]*)url\(['"]?\{%(\$.*?)%\}['"]?\)/gi, function(word, key){
        var ret = word.replace(key, key + '|wiki_common_https_trans');
        if( ret !== word) {
            console.log('🏃 ==> replacement 9::' + '[' + word + ']' + ' => [' + ret + ']');
        }
        return ret;
    })
    // 匹配 "background:{%$data.bgColor%} {%if $lang == 'en'%}url({%$data.en_bgImg|wiki_common_pic_src2url%}){%else%}url({%$data.bgImg|wiki_common_pic_src2url%}){%/if%} center center  no-repeat;"
    // 这种 url 和 background: 之间包涵其他字符，且后面可能包含多个url的字段
    .replace(/background(?:\-image)?:\s*([^;]*)/, function (word, key) {
        var newKey = key.replace(/url\(\{\%([^%]+)\%\}\)/gi, function (word, match1, index, key) {
            return word.replace(match1, match1 + '|wiki_common_https_trans');
        });
        var ret = word.replace(key, newKey);
        if (ret !== word) {
            console.log('🏋 ==> replacement 10::' + '[' + word + ']' + ' => [' + ret + ']');
        }
        return ret;
    });
};

function httpsCssReplace(content) {
    // 匹配出 http://d.hiphotos.baidu.com 这种url host，并替换为对应的https url host
    return content.replace(/background(?:\-image)?:\s*(?:#(?:[A-Za-z0-9]{3}|[A-Za-z0-9]{6})\s+)?url\((http:\/\/[\w\.\-]+).*?\)/gi, function(word, key){
        var ret = httpsTransMap[key] ? word.replace(key, httpsTransMap[key]) : word;
        console.log('💖 ==> list background in css::' + '[' + word + ']' + ' => [' + ret + ']');
        if( ret !== word) {
            console.log('💖 ==> replacement 11::' + '[' + word + ']' + ' => [' + ret + ']');
        }
        return ret;
    });
}

function httpsJSReplace(content) {
    // var reg = /\'\s*(http:[\w\d\.\-#\?&=\/]+?)\s*?\'|\"\s*(http:[\w\d\.\-#\?&=\/]+?)\s*?\"/gi;
    var reg = /\'\s*(http:[\w\d\.\-#\?&=\/%]+)\s*?\'|\"\s*(http:[\w\d\.\-#\?&=\/％]+)\s*?\"/gi;
    return content.replace(reg, function(word, match1, match2){
        var match = match1 || match2;
        var origin = word;
        var ret = match.replace(/^(http:\/\/[\w\d\.\-]+).*/, function(url, host){
            return httpsTransMap[host] ? url.replace(host, httpsTransMap[host]) : url;
        });
        if(ret !== match){
            word = word.replace(match, ret);
            console.log('💋 ==> replacement 12::' + '[' + origin + ']' + ' => [' + word + ']');
        }
        return word;
    });
}


var exports = module.exports = function(ret, conf, settings, opt) {
    
    var ld = settings.left_delimiter || fis.config.get('settings.smarty.left_delimiter') || '{%';
    var rd = settings.right_delimiter || fis.config.get('settings.smarty.right_delimiter') || '%}';
    
    var ids = ret.ids || {};

    fis.util.map(ids, function (src, file) {
        if ( /^\.tpl|\.js|\.css$/.test(file.rExt)) {
            var origin = file.getContent();
            var content = origin;
            switch (file.rExt) {
                case '.tpl':
                content = httpsTplReplace(content);
                break;

                case '.js': 
                if (file.id !== 'wiki-common:widget/lib/jsmart/jsmart.js') {
                    content = httpsJSReplace(content);
                }
                break;

                case '.css':
                content = httpsCssReplace(content);
                break;
            }
            if(content !== origin) {
                console.log('✨✨✨[LOG] Replacements completed in [ ' + file.id + ' ]✨✨✨');
            }
            file.setContent(content);
        }
    });
};